# class FileSizeValidator

### Constants

CHECKS
DEFAULT_TOKENIZER
MESSAGES
RESERVED_OPTIONS

### Public Class Methods

new(options) click to toggle source

    # File lib/file_size_validator.rb, line 8
    def initialize(options)
      if range = (options.delete(:in) || options.delete(:within))
        raise ArgumentError, ":in and :within must be a Range" unless range.is_a?(Range)
        options[:minimum], options[:maximum] = range.begin, range.end
        options[:maximum] -= 1 if range.exclude_end?
      end

      super
    end

### Public Instance Methods

check_validity!() click to toggle source

    # File lib/file_size_validator.rb, line 18
    def check_validity!
      keys = CHECKS.keys & options.keys

      if keys.empty?
        raise ArgumentError, 'Range unspecified. Specify the :within, :maximum, :minimum, or :is option.'
      end

      keys.each do |key|
        value = options[key]

        unless value.is_a?(Integer) && value >= 0
          raise ArgumentError, ":#{key} must be a nonnegative Integer"
        end
      end
    end

help() click to toggle source

    # File lib/file_size_validator.rb, line 57
    def help
      Helper.instance
    end

validate_each(record, attribute, value) click to toggle source

    # File lib/file_size_validator.rb, line 34
    def validate_each(record, attribute, value)
      raise(ArgumentError, "A CarrierWave::Uploader::Base object was expected") unless value.kind_of? CarrierWave::Uploader::Base

      value = (options[:tokenizer] || DEFAULT_TOKENIZER).call(value) if value.kind_of?(String)

      CHECKS.each do |key, validity_check|
        next unless check_value = options[key]

        value ||= [] if key == :maximum

        value_size = value.size
        next if value_size.send(validity_check, check_value)

        errors_options = options.except(*RESERVED_OPTIONS)
        errors_options[:file_size] = help.number_to_human_size check_value

        default_message = options[MESSAGES[key]]
        errors_options[:message] ||= default_message if default_message

        record.errors.add(attribute, MESSAGES[key], errors_options)
      end
    end